/* GCC */
#include <bits/stdc++.h>
using namespace std;
const int Deep = 25;
const double MaxR = 1000.0, PI = acos(-1.0), e = 0.00000001;
int n, k;

struct point
{
    double x, y;
};

vector<point> dots;

void DataRead()
{
    cin>> n >> k;
    dots.resize(n);

    for(int i = 0; i < n; i++)
        cin>> dots[i].x >> dots[i].y;
}

void DataProcess()
{
    double r1 = 0.0, r2 = MaxR;
    vector<pair<double, int> > line;

    for(int d = 0; d < Deep; d++)
    {
        double r = (r1 + r2) / 2.0;
        int best_c = 1;
        for(int first = 0; first < n; first++)
        {
            line.clear();
            int c = 1;
            for(int i = 0; i < n; i++)
            {
                if(i == first)
                    continue;
                double len = hypot(dots[i].x - dots[first].x, dots[i].y - dots[first].y);
                if(len - 2 * r > e)
                    continue;

                double h = dots[i].y - dots[first].y;
                double betta = PI / 2 - asin(len / (2 * r)), phi;

                if(dots[i].x - dots[first].x > e)
                    phi = asin(h / len);
                else
                    phi = PI - asin(h / len);

                double alpha1 = phi - betta;
                double alpha2 = phi + betta;
                line.push_back(make_pair(alpha1, 1));
                line.push_back(make_pair(alpha2, -1));
            }
            sort(line.begin(), line.end());

            for(int i = 0; i < line.size(); i++)
            {
                c += line[i].second;
                best_c = max(best_c, c);
            }
        }

        if(best_c < k)
            r1 = r;
        else
            r2 = r;
    }

    cout<< fixed << setprecision(3) << (r1 + r2) / 2.0 << "\n";
}

int main()
{
    freopen("circle.in", "r", stdin);
    freopen("circle.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    DataRead();
    DataProcess();

    return 0;
}
